#include <stdio.h>
#include <locale.h>
#include <wchar.h>
#include <wctype.h>
#include <malloc.h>

int main( int args, char* argv[] )
{
	if (!setlocale(LC_CTYPE, "")) {
		fprintf(stderr, "Can't set the specified locale! "
						"Check LANG, LC_CTYPE, LC_ALL.\n");
		return 1;
	}
	FILE* in = fopen( argv[1], "r" );
	if( in==NULL ) {
		printf( "can't read %s\n", argv[1] );
		return 1;
	}
	
	wchar_t ch;
	while( (ch=fgetwc(in))!=WEOF ) {
		wchar_t up = towupper(ch);
		printf( "towupper(%04lx '%lc') = %04x '%lc'\n", ch, ch, up, up );
	}
	fclose(in);
	return 0;
}
